library api_error;

import 'dart:convert';

import 'package:built_collection/built_collection.dart';
import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';
import 'package:puma_network/serializers.dart';

part 'apiError.g.dart';

abstract class ApiError implements Built<ApiError, ApiErrorBuilder> {
  ApiError._();

  factory ApiError([updates(ApiErrorBuilder b)]) = _$ApiError;

  @BuiltValueField(wireName: 'status')
  int? get status;

  @BuiltValueField(wireName: 'uuid')
  String? get uuid;

  @BuiltValueField(wireName: 'errorCode')
  String? get errorCode;

  @BuiltValueField(wireName: 'description')
  String? get description;

  @BuiltValueField(wireName: 'resolution')
  String? get resolution;

  @BuiltValueField(wireName: 'action')
  String? get action;

  @BuiltValueField(wireName: 'function')
  String? get function;

  @BuiltValueField(wireName: 'stack')
  BuiltList<String>? get stack;

  String toJson() {
    return json.encode(serializers.serializeWith(ApiError.serializer, this));
  }

  static ApiError? fromJson(String jsonString) {
    return serializers.deserializeWith(
        ApiError.serializer, json.decode(jsonString));
  }

  static Serializer<ApiError> get serializer => _$apiErrorSerializer;
}
