import 'dart:core';

import 'package:puma_core/helpers.dart';
import 'package:puma_network/redux/api/apiAction.dart';
import 'package:puma_network/redux/network/networkState.dart';
import 'package:redux/redux.dart';

Uri uriBuilder(bool https, String apiEndpoint, dynamic path) {
  return https ? Uri.https(apiEndpoint, path) : Uri.http(apiEndpoint, path);
}

Uri uriBuilderParams(
    bool https, String apiEndpoint, dynamic path, Map<String, String> params) {
  return https
      ? Uri.https(apiEndpoint, path, params)
      : Uri.http(apiEndpoint, path, params);
}

String withNetworkCompletionDispatch(Store store, APIAction action) {
  var networkCompletionKey = getRandString(10);
  action.setNetworkCompletionKey(networkCompletionKey);
  store.dispatch(action);
  return networkCompletionKey;
}

String getFinalEndpoint(String url, NetworkState state) {
  if (url.length > 0) return url;

  return state.apiEndpoint;
}
