import 'package:puma_core/redux/core/coreAction.dart';
import 'package:puma_network/constants.dart';

class InitNetworkAction extends CoreAction {
  final int timestamp;
  final String dispatcherKey = constDispatcherKey;
  final String apiEndpoint;
  final bool https;

  InitNetworkAction(this.apiEndpoint, {this.https = true})
      : this.timestamp = DateTime.now().millisecondsSinceEpoch;
}

class SetImpersonateTokenNetworkAction extends CoreAction {
  final int timestamp;
  final String dispatcherKey = constDispatcherKey;
  final String? authImpersonateToken;

  SetImpersonateTokenNetworkAction({this.authImpersonateToken})
      : this.timestamp = DateTime.now().millisecondsSinceEpoch;
}

class SetTokenNetworkAction extends CoreAction {
  final int timestamp;
  final String dispatcherKey = constDispatcherKey;
  final String token;
  SetTokenNetworkAction(this.token)
      : this.timestamp = DateTime.now().millisecondsSinceEpoch;
}

class SetBiometricTokenNetworkAction extends CoreAction {
  final int timestamp;
  final String dispatcherKey = constDispatcherKey;
  final String token;
  SetBiometricTokenNetworkAction(this.token)
      : this.timestamp = DateTime.now().millisecondsSinceEpoch;
}

class ClearTokenNetworkAction extends CoreAction {
  final int timestamp;
  final String dispatcherKey = constDispatcherKey;
  ClearTokenNetworkAction()
      : this.timestamp = DateTime.now().millisecondsSinceEpoch;
}

class ClearLastApiError extends CoreAction {
  final int timestamp;
  final String dispatcherKey = constDispatcherKey;
  ClearLastApiError() : this.timestamp = DateTime.now().millisecondsSinceEpoch;
}
